geos::algorithm::InteriorPointArea Class Reference

Computes a point in the interior of an areal geometry. The point will lie in the geometry interior in all except certain pathological cases. More...

`#include <InteriorPointArea.h>`

## Public Member Functions

| InteriorPointArea (const geom::Geometry *g)
bool | getInteriorPoint (geom::Coordinate &ret) const

## Detailed Description

Computes a point in the interior of an areal geometry. The point will lie in the geometry interior in all except certain pathological cases.

## Algorithm

For each input polygon:

- Determine a horizontal scan line on which the interior point will be located. To increase the chance of the scan line having non-zero-width intersection with the polygon the scan line Y ordinate is chosen to be near the centre of the polygon's Y extent but distinct from all of vertex Y ordinates.
- Compute the sections of the scan line which lie in the interior of the polygon.
- Choose the widest interior section and take its midpoint as the interior point.

The final interior point is chosen as the one occurring in the widest interior section.

This algorithm is a tradeoff between performance and point quality (where points further from the geometry boundary are considered to be higher quality) Priority is given to performance. This means that the computed interior point may not be suitable for some uses (such as label positioning).

The algorithm handles some kinds of invalid/degenerate geometry, including zero-area and self-intersecting polygons.

Empty geometry is handled by returning a `null` point.

### KNOWN BUGS

- If a fixed precision model is used, in some cases this method may return a point which does not lie in the interior.
- If the input polygon is extremely narrow the computed point may not lie in the interior of the polygon.

## Constructor & Destructor Documentation

## InteriorPointArea()

geos::algorithm::InteriorPointArea::InteriorPointArea | ( | const geom::Geometry * | g | ) |

Creates a new interior point finder for an areal geometry.

Parameters

  g | an areal geometry

## Member Function Documentation

## getInteriorPoint()

bool geos::algorithm::InteriorPointArea::getInteriorPoint | ( | geom::Coordinate & | ret | ) | const

Gets the computed interior point.

Returns
  the coordinate of an interior point or `null` if the input geometry is empty

The documentation for this class was generated from the following file:

- InteriorPointArea.h